ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
Revision: 2.47
Committed: Thu Apr 24 23:08:08 2014 UTC (10 years ago) by greg
Content type: text/plain
Branch: MAIN
Changes since 2.46: +293 -166 lines
Log Message:
Andy finished making genBSDF Windows-compatible

File Contents

# Content
1 #!/usr/bin/perl -w
2 # RCSid $Id$
3 #
4 # Compute BSDF based on geometry and material description
5 #
6 # G. Ward
7 #
8 use strict;
9 my $windoz = ($^O eq "MSWin32" or $^O eq "MSWin64");
10 use File::Temp qw/ :mktemp /;
11 sub userror {
12 print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
13 exit 1;
14 }
15 my ($td,$radscn,$mgfscn,$octree,$cnttmp,$rmtmp);
16 if ($windoz) {
17 my $tmploc = `echo \%TMP\%`;
18 chomp($tmploc);
19 $td = mkdtemp("$tmploc\\genBSDF.XXXXXX");
20 $radscn = "$td\\device.rad";
21 $mgfscn = "$td\\device.mgf";
22 $octree = "$td\\device.oct";
23 chomp $td;
24 $rmtmp = "rmdir /S /Q $td";
25 } else{
26 $td = mkdtemp("/tmp/genBSDF.XXXXXX");
27 chomp $td;
28 $radscn = "$td/device.rad";
29 $mgfscn = "$td/device.mgf";
30 $octree = "$td/device.oct";
31 $rmtmp = "rm -rf $td";
32 }
33 my @savedARGV = @ARGV;
34 my $tensortree = 0;
35 my $ttlog2 = 4;
36 my $nsamp = 2000;
37 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
38 my $mgfin = 0;
39 my $geout = 1;
40 my $nproc = 1;
41 my $doforw = 0;
42 my $doback = 1;
43 my $pctcull = 90;
44 my $gunit = "meter";
45 my @dim;
46 # Get options
47 while ($#ARGV >= 0) {
48 if ("$ARGV[0]" =~ /^[-+]m/) {
49 $mgfin = ("$ARGV[0]" =~ /^\+/);
50 } elsif ("$ARGV[0]" eq "-r") {
51 $rtargs = "$rtargs $ARGV[1]";
52 shift @ARGV;
53 } elsif ("$ARGV[0]" =~ /^[-+]g/) {
54 $geout = ("$ARGV[0]" =~ /^\+/);
55 $gunit = $ARGV[1];
56 if ($gunit !~ /^(?i)(meter|foot|inch|centimeter|millimeter)$/) {
57 die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
58 }
59 shift @ARGV;
60 } elsif ("$ARGV[0]" =~ /^[-+]f/) {
61 $doforw = ("$ARGV[0]" =~ /^\+/);
62 } elsif ("$ARGV[0]" =~ /^[-+]b/) {
63 $doback = ("$ARGV[0]" =~ /^\+/);
64 } elsif ("$ARGV[0]" eq "-t") {
65 # Use value < 0 for rttree_reduce bypass
66 $pctcull = $ARGV[1];
67 shift @ARGV;
68 } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
69 $tensortree = substr($ARGV[0], 2, 1);
70 $ttlog2 = $ARGV[1];
71 shift @ARGV;
72 } elsif ("$ARGV[0]" eq "-c") {
73 $nsamp = $ARGV[1];
74 shift @ARGV;
75 } elsif ("$ARGV[0]" eq "-n") {
76 $nproc = $ARGV[1];
77 shift @ARGV;
78 } elsif ("$ARGV[0]" =~ /^-d/) {
79 userror() if ($#ARGV < 6);
80 @dim = @ARGV[1..6];
81 shift @ARGV for (1..6);
82 } elsif ("$ARGV[0]" =~ /^[-+]./) {
83 userror();
84 } else {
85 last;
86 }
87 shift @ARGV;
88 }
89 # Check that we're actually being asked to do something
90 die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
91 # Get scene description and dimensions
92
93 if ( $mgfin ) {
94 system qq{mgfilt "#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus" @ARGV > $mgfscn};
95 die "Could not load MGF input\n" if ( $? );
96 system "mgf2rad $mgfscn > $radscn";
97 } else {
98 system "xform -e @ARGV > $radscn";
99 die "Could not load Radiance input\n" if ( $? );
100 system "rad2mgf $radscn > $mgfscn" if ( $geout );
101 }
102 if ($#dim != 5) {
103 @dim = split ' ', `getbbox -h $radscn`;
104 }
105 print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
106 # Add receiver surfaces (rectangular)
107 my $fmodnm="receiver_face";
108 my $bmodnm="receiver_behind";
109 open(RADSCN, ">> $radscn");
110 print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
111 print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
112 print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
113 print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
114 close RADSCN;
115 # Generate octree
116 system "oconv -w $radscn > $octree";
117 die "Could not compile scene\n" if ( $? );
118 # Output XML prologue
119 print
120 '<?xml version="1.0" encoding="UTF-8"?>
121 <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
122 ';
123 print "<!-- File produced by: genBSDF @savedARGV -->\n";
124 print
125 '<WindowElementType>System</WindowElementType>
126 <FileType>BSDF</FileType>
127 <Optical>
128 <Layer>
129 <Material>
130 <Name>Name</Name>
131 <Manufacturer>Manufacturer</Manufacturer>
132 ';
133 printf qq{\t\t<Thickness unit="$gunit">%.6f</Thickness>\n}, $dim[5] - $dim[4];
134 printf qq{\t\t<Width unit="$gunit">%.6f</Width>\n}, $dim[1] - $dim[0];
135 printf qq{\t\t<Height unit="$gunit">%.6f</Height>\n}, $dim[3] - $dim[2];
136 print "\t\t<DeviceType>Other</DeviceType>\n";
137 print "\t</Material>\n";
138 # Output MGF description if requested
139 if ( $geout ) {
140 print qq{\t\t<Geometry format="MGF">\n};
141 print qq{\t\t<MGFblock unit="$gunit">\n};
142 printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
143 open(MGFSCN, "< $mgfscn");
144 while (<MGFSCN>) { print $_; }
145 close MGFSCN;
146 print "xf\n";
147 print "</MGFblock>\n";
148 print "\t</Geometry>\n";
149 }
150 # Set up surface sampling
151 my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + 1);
152 my $ny = int($nsamp/$nx + 1);
153 $nsamp = $nx * $ny;
154 my $ns = 2**$ttlog2;
155 my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
156 # Create data segments (all the work happens here)
157 if ( $tensortree ) {
158 do_tree_bsdf();
159 } else {
160 do_matrix_bsdf();
161 }
162 # Output XML epilogue
163 print
164 '</Layer>
165 </Optical>
166 </WindowElement>
167 ';
168 # Clean up temporary files and exit
169 system $rmtmp;
170
171 #-------------- End of main program segment --------------#
172
173 #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
174 sub do_tree_bsdf {
175 # Shirley-Chiu mapping from unit square to disk
176 $sq2disk = 'in_square_a = 2*in_square_x - 1; ' .
177 'in_square_b = 2*in_square_y - 1; ' .
178 'in_square_rgn = if(in_square_a + in_square_b, ' .
179 'if(in_square_a - in_square_b, 1, 2), ' .
180 'if(in_square_b - in_square_a, 3, 4)); ' .
181 'out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b, ' .
182 '-in_square_a, -in_square_b); ' .
183 'out_disk_phi = PI/4 * select(in_square_rgn, ' .
184 'in_square_b/in_square_a, ' .
185 '2 - in_square_a/in_square_b, ' .
186 '4 + in_square_b/in_square_a, ' .
187 'if(in_square_b*in_square_b, ' .
188 '6 - in_square_a/in_square_b, 0)); ' .
189 'Dx = out_disk_r*cos(out_disk_phi); ' .
190 'Dy = out_disk_r*sin(out_disk_phi); ' .
191 'Dz = sqrt(1 - out_disk_r*out_disk_r);' ;
192 # Shirley-Chiu mapping from unit disk to square
193 $disk2sq = 'norm_radians(p) : if(-p - PI/4, p + 2*PI, p); ' .
194 'in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy); ' .
195 'in_disk_phi = norm_radians(atan2(Dy, Dx)); ' .
196 'in_disk_rgn = floor((.999995*in_disk_phi + PI/4)/(PI/2)) + 1; ' .
197 'out_square_a = select(in_disk_rgn, ' .
198 'in_disk_r, ' .
199 '(PI/2 - in_disk_phi)*in_disk_r/(PI/4), ' .
200 '-in_disk_r, ' .
201 '(in_disk_phi - 3*PI/2)*in_disk_r/(PI/4)); ' .
202 'out_square_b = select(in_disk_rgn, ' .
203 'in_disk_phi*in_disk_r/(PI/4), ' .
204 'in_disk_r, ' .
205 '(PI - in_disk_phi)*in_disk_r/(PI/4), ' .
206 '-in_disk_r); ' .
207 'out_square_x = (out_square_a + 1)/2; ' .
208 'out_square_y = (out_square_b + 1)/2;';
209 # Announce ourselves in XML output
210 print "\t<DataDefinition>\n";
211 print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
212 print "\t</DataDefinition>\n";
213
214 # Start rcontrib processes for compute each side
215 do_tree_rtcontrib(0) if ( $doback );
216 do_tree_rtcontrib(1) if ( $doforw );
217
218 } # end of sub do_tree_bsdf()
219
220 # Run rcontrib process to generate tensor tree samples
221 sub do_tree_rtcontrib {
222 my $forw = shift;
223 my $cmd;
224 my $matargs = "-m $bmodnm";
225 if ( !$forw || !$doback || $tensortree==3 ) { $matargs .= " -m $fmodnm"; }
226 if ($windoz) {
227 $cmd = "rcontrib $rtargs -h -faa -fo -n $nproc -c $nsamp " .
228 qq{-e "$disk2sq" -bn "$ns*$ns" } .
229 qq{-b "$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)" } .
230 "-o $td/%s.flt $matargs $octree";
231 } else {
232 $cmd = "rcontrib $rtargs -h -fff -fo -n $nproc -c $nsamp " .
233 qq{-e "$disk2sq" -bn "$ns*$ns" } .
234 qq{-b "$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)" } .
235 "-o $td/%s.flt $matargs $octree";
236 }
237 if ( $tensortree == 3 ) {
238 # Isotropic BSDF
239 my $ns2 = $ns / 2;
240 if ($windoz) {
241 $cmd = "cnt $ns2 $ny $nx " .
242 qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
243 qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
244 qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
245 qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
246 qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
247 qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
248 qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
249 qq{-e "\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz" } .
250 qq{-e "\$4=Dx;\$5=Dy;\$6=myDz" } .
251 "| $cmd";
252 } else {
253 $cmd = "cnt $ns2 $ny $nx " .
254 qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
255 qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
256 qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
257 qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
258 qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
259 qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
260 qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
261 qq{-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' } .
262 qq{-e '\$4=Dx;\$5=Dy;\$6=myDz' -of } .
263 "| $cmd";
264 }
265 } else {
266 # Anisotropic BSDF
267 # Sample area vertically to improve load balance, since
268 # shading systems usually have bilateral symmetry (L-R)
269 if ($windoz) {
270 $cmd = "cnt $ns $ns $ny $nx " .
271 qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
272 qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
273 qq{-e "r3=rand(3.17603772*recno+83.766771)" } .
274 qq{-e "r4=rand(-2.3857833*recno-964.72738)" } .
275 qq{-e "in_square_x=(\$1+r1)/$ns" } .
276 qq{-e "in_square_y=(\$2+r2)/$ns" -e "$sq2disk" } .
277 qq{-e "xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
278 qq{-e "yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
279 qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
280 qq{-e "\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz" } .
281 qq{-e "\$4=Dx;\$5=Dy;\$6=myDz" } .
282 "| $cmd";
283 } else {
284 $cmd = "cnt $ns $ns $ny $nx " .
285 qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
286 qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
287 qq{-e "r3=rand(3.17603772*recno+83.766771)" } .
288 qq{-e "r4=rand(-2.3857833*recno-964.72738)" } .
289 qq{-e "in_square_x=(\$1+r1)/$ns" } .
290 qq{-e "in_square_y=(\$2+r2)/$ns" -e "$sq2disk" } .
291 qq{-e "xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
292 qq{-e "yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
293 qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
294 qq{-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' } .
295 qq{-e '\$4=Dx;\$5=Dy;\$6=myDz' -of } .
296 "| $cmd";
297 }
298 }
299 # print STDERR "Starting: $cmd\n";
300 system "$cmd" || die "Failure running rcontrib";
301 ttree_out($forw);
302 } # end of do_tree_rtcontrib()
303
304 # Simplify and output tensor tree results
305 sub ttree_out {
306 my $forw = shift;
307 my $side = ("Back","Front")[$forw];
308 my $cmd;
309 # Only output one transmitted anisotropic distribution, preferring backwards
310 if ( !$forw || !$doback || $tensortree==3 ) {
311 print
312 ' <WavelengthData>
313 <LayerNumber>System</LayerNumber>
314 <Wavelength unit="Integral">Visible</Wavelength>
315 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
316 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
317 <WavelengthDataBlock>' ;
318 print "\t\t\t<WavelengthDataDirection>Transmission $side</WavelengthDataDirection>\n";
319 print
320 ' <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
321 <ScatteringDataType>BTDF</ScatteringDataType>
322 <ScatteringData>
323 ';
324 if ($windoz) {
325 $cmd = qq{rcalc -e "Omega:PI/($ns*$ns)" } .
326 q{-e "$1=(0.265*$1+0.670*$2+0.065*$3)/Omega" };
327 } else {
328 $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
329 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
330 }
331 if ($pctcull >= 0) {
332 if ($windoz) {
333 $cmd = "rcollate -h -oc 1 $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt | " .
334 $cmd .
335 "| rttree_reduce -h -fa -t $pctcull -r $tensortree -g $ttlog2";
336 } else {
337 $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt " .
338 " | rttree_reduce -h -ff -t $pctcull -r $tensortree -g $ttlog2";
339 }
340 system "$cmd" || die "Failure running rttree_reduce";
341 } else {
342 if ($windoz) {
343 $cmd = "rcollate -h -oc 1 $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt | " .
344 $cmd ;
345 } else {
346 $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . ".flt";
347 }
348 print "{\n";
349 system "$cmd" || die "Failure running rcalc";
350 for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
351 print "0\n";
352 }
353 print "}\n";
354 }
355 print
356 ' </ScatteringData>
357 </WavelengthDataBlock>
358 </WavelengthData>
359 ';
360 }
361 # Output reflection
362 print
363 ' <WavelengthData>
364 <LayerNumber>System</LayerNumber>
365 <Wavelength unit="Integral">Visible</Wavelength>
366 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
367 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
368 <WavelengthDataBlock>
369 ';
370 print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
371 print
372 ' <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
373 <ScatteringDataType>BTDF</ScatteringDataType>
374 <ScatteringData>
375 ';
376 if ($windoz) {
377 $cmd = qq{rcalc -e "Omega:PI/($ns*$ns)" } .
378 q{-e "$1=(0.265*$1+0.670*$2+0.065*$3)/Omega" };
379 }else {
380 $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
381 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
382 }
383 if ($pctcull >= 0) {
384 if ($windoz) {
385 $cmd = "rcollate -h -oc 1 $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt |" .
386 $cmd .
387 " | rttree_reduce -a -h -fa -t $pctcull -r $tensortree -g $ttlog2";
388
389 } else {
390 $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt " .
391 "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
392 }
393 system "$cmd" || die "Failure running rttree_reduce";
394 } else {
395 if ($windoz) {
396 $cmd = "rcollate -h -oc 1 $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt |" .
397 $cmd ;
398 } else {
399 $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . ".flt";
400 }
401 print "{\n";
402 system "$cmd" || die "Failure running rcalc";
403 for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
404 print "0\n";
405 }
406 print "}\n";
407 }
408 print
409 ' </ScatteringData>
410 </WavelengthDataBlock>
411 </WavelengthData>
412 ';
413 } # end of ttree_out()
414
415 #------------- End of do_tree_bsdf() & subroutines -------------#
416
417 #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
418 sub do_matrix_bsdf {
419 # Set up sampling of portal
420 # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
421 $tcal = 'DEGREE : PI/180; ' .
422 'sq(x) : x*x; ' .
423 'Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90); ' .
424 'Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12); ' .
425 'Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0); ' .
426 'Kmax : Kaccum(Knaz(0)); ' .
427 'Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r); ' .
428 'Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin)); ' .
429 'Kcol = Kbin - Kaccum(Krow-1); ' .
430 'Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow); ' .
431 'Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1)); ' .
432 'sin_kpol = sin(Kpol); ' .
433 'Dx = cos(Kazi)*sin_kpol; ' .
434 'Dy = sin(Kazi)*sin_kpol; ' .
435 'Dz = sqrt(1 - sin_kpol*sin_kpol); ' .
436 'KprojOmega = PI * if(Kbin-.5, ' .
437 '(sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow), ' .
438 '1 - sq(cos(Kpola(1)*DEGREE))); ';
439 # Compute Klems bin from exiting ray direction (forward or backward)
440 $kcal = 'DEGREE : PI/180; ' .
441 'abs(x) : if(x, x, -x); ' .
442 'Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x)))/DEGREE; ' .
443 'posangle(a) : if(-a, a + 2*PI, a); ' .
444 'Atan2(y,x) : posangle(atan2(y,x))/DEGREE; ' .
445 'kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90); ' .
446 'knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12); ' .
447 'kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0); ' .
448 'kfindrow(r, pol) : if(r-kpola(0)+.5, r, ' .
449 'if(pol-kpola(r), kfindrow(r+1, pol), r) ); ' .
450 'kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0); ' .
451 'kbin2(pol,azi) = select(kfindrow(1, pol), ' .
452 'kazn(azi,360/knaz(1)), ' .
453 'kaccum(1) + kazn(azi,360/knaz(2)), ' .
454 'kaccum(2) + kazn(azi,360/knaz(3)), ' .
455 'kaccum(3) + kazn(azi,360/knaz(4)), ' .
456 'kaccum(4) + kazn(azi,360/knaz(5)), ' .
457 'kaccum(5) + kazn(azi,360/knaz(6)), ' .
458 'kaccum(6) + kazn(azi,360/knaz(7)), ' .
459 'kaccum(7) + kazn(azi,360/knaz(8)), ' .
460 'kaccum(8) + kazn(azi,360/knaz(9)) ' .
461 '); ' .
462 'kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));';
463 my $ndiv = 145;
464 # Compute scattering data using rcontrib
465 my @tfarr;
466 my @rfarr;
467 my @tbarr;
468 my @rbarr;
469 my (@data,@line); # for windows
470 my $cmd;
471 my $rtcmd;
472 my $rccmd;
473 if ($windoz) {
474 $rtcmd = "rcontrib $rtargs -h -fo -n $nproc -c $nsamp " .
475 qq{-e "$kcal" -b kbin -bn $ndiv } .
476 qq{-o "$td\\%s.flt" -m $fmodnm -m $bmodnm $octree };
477 $rccmd = qq{rcalc -e "$tcal" } .
478 qq{-e "mod(n,d):n-floor(n/d)*d" -e "Kbin=mod(recno-.999,$ndiv)" } .
479 q{ -e "$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega" };
480 } else {
481 $rtcmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
482 "-e '$kcal' -b kbin -bn $ndiv " .
483 "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
484 $rccmd = "rcalc -e '$tcal' " .
485 "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
486 q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
487 }
488 if ( $doforw ) {
489 if ($windoz) {
490 $cmd = qq{cnt $ndiv $ny $nx | rcalc -e "$tcal" } .
491 qq{-e "xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
492 qq{-e "yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
493 qq{-e "zp:$dim[4]" } .
494 q{-e "Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)" } .
495 q{-e "$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz" } .
496 "| $rtcmd ";
497 } else {
498 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
499 "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
500 "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
501 "-e 'zp:$dim[4]' " .
502 q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
503 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
504 "| $rtcmd";
505 }
506 system "$cmd" || die "Failure running: $cmd\n";
507 if ($windoz) {
508 @tfarr = `rcollate -h -oc 1 $td\\$fmodnm.flt | $rccmd`;
509 } else {
510 @tfarr = `$rccmd $td/$fmodnm.flt`;
511 }
512 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
513 if ($windoz) {
514 @rfarr = `rcollate -h -oc 1 $td\\$bmodnm.flt | $rccmd`;
515 } else {
516 @rfarr = `$rccmd $td/$bmodnm.flt`;
517 }
518 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
519 }
520 if ( $doback ) {
521 if ($windoz) {
522 $cmd = qq{cnt $ndiv $ny $nx | rcalc -e "$tcal" } .
523 qq{-e "xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
524 qq{-e "yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
525 qq{-e "zp:$dim[5]" } .
526 q{-e "Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)" } .
527 q{-e "$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz" } .
528 "| $rtcmd";
529 } else {
530 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
531 "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
532 "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
533 "-e 'zp:$dim[5]' " .
534 q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
535 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
536 "| $rtcmd";
537 }
538 system "$cmd" || die "Failure running: $cmd\n";
539 if ($windoz) {
540 @tbarr = `rcollate -h -oc 1 $td\\$bmodnm.flt | $rccmd`;
541 } else {
542 @tbarr = `$rccmd $td/$bmodnm.flt`;
543 }
544 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
545 chomp(@tbarr);
546 if ($windoz) {
547 @rbarr = `rcollate -h -oc 1 $td\\$fmodnm.flt | $rccmd`;
548 } else {
549 @rbarr = `$rccmd $td/$fmodnm.flt`;
550 }
551 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
552 chomp(@rbarr);
553 }
554
555 # Output angle basis
556 print
557 ' <DataDefinition>
558 <IncidentDataStructure>Columns</IncidentDataStructure>
559 <AngleBasis>
560 <AngleBasisName>LBNL/Klems Full</AngleBasisName>
561 <AngleBasisBlock>
562 <Theta>0</Theta>
563 <nPhis>1</nPhis>
564 <ThetaBounds>
565 <LowerTheta>0</LowerTheta>
566 <UpperTheta>5</UpperTheta>
567 </ThetaBounds>
568 </AngleBasisBlock>
569 <AngleBasisBlock>
570 <Theta>10</Theta>
571 <nPhis>8</nPhis>
572 <ThetaBounds>
573 <LowerTheta>5</LowerTheta>
574 <UpperTheta>15</UpperTheta>
575 </ThetaBounds>
576 </AngleBasisBlock>
577 <AngleBasisBlock>
578 <Theta>20</Theta>
579 <nPhis>16</nPhis>
580 <ThetaBounds>
581 <LowerTheta>15</LowerTheta>
582 <UpperTheta>25</UpperTheta>
583 </ThetaBounds>
584 </AngleBasisBlock>
585 <AngleBasisBlock>
586 <Theta>30</Theta>
587 <nPhis>20</nPhis>
588 <ThetaBounds>
589 <LowerTheta>25</LowerTheta>
590 <UpperTheta>35</UpperTheta>
591 </ThetaBounds>
592 </AngleBasisBlock>
593 <AngleBasisBlock>
594 <Theta>40</Theta>
595 <nPhis>24</nPhis>
596 <ThetaBounds>
597 <LowerTheta>35</LowerTheta>
598 <UpperTheta>45</UpperTheta>
599 </ThetaBounds>
600 </AngleBasisBlock>
601 <AngleBasisBlock>
602 <Theta>50</Theta>
603 <nPhis>24</nPhis>
604 <ThetaBounds>
605 <LowerTheta>45</LowerTheta>
606 <UpperTheta>55</UpperTheta>
607 </ThetaBounds>
608 </AngleBasisBlock>
609 <AngleBasisBlock>
610 <Theta>60</Theta>
611 <nPhis>24</nPhis>
612 <ThetaBounds>
613 <LowerTheta>55</LowerTheta>
614 <UpperTheta>65</UpperTheta>
615 </ThetaBounds>
616 </AngleBasisBlock>
617 <AngleBasisBlock>
618 <Theta>70</Theta>
619 <nPhis>16</nPhis>
620 <ThetaBounds>
621 <LowerTheta>65</LowerTheta>
622 <UpperTheta>75</UpperTheta>
623 </ThetaBounds>
624 </AngleBasisBlock>
625 <AngleBasisBlock>
626 <Theta>82.5</Theta>
627 <nPhis>12</nPhis>
628 <ThetaBounds>
629 <LowerTheta>75</LowerTheta>
630 <UpperTheta>90</UpperTheta>
631 </ThetaBounds>
632 </AngleBasisBlock>
633 </AngleBasis>
634 </DataDefinition>
635 ';
636 if ( $doforw ) {
637 print
638 ' <WavelengthData>
639 <LayerNumber>System</LayerNumber>
640 <Wavelength unit="Integral">Visible</Wavelength>
641 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
642 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
643 <WavelengthDataBlock>
644 <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
645 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
646 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
647 <ScatteringDataType>BTDF</ScatteringDataType>
648 <ScatteringData>
649 ';
650 # Output front transmission (transposed order)
651 for (my $od = 0; $od < $ndiv; $od++) {
652 for (my $id = 0; $id < $ndiv; $id++) {
653 chomp $tfarr[$ndiv*$id + $od];
654 print $tfarr[$ndiv*$id + $od], ",\t";
655 }
656 print "\n";
657 }
658 print
659 ' </ScatteringData>
660 </WavelengthDataBlock>
661 </WavelengthData>
662 <WavelengthData>
663 <LayerNumber>System</LayerNumber>
664 <Wavelength unit="Integral">Visible</Wavelength>
665 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
666 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
667 <WavelengthDataBlock>
668 <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
669 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
670 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
671 <ScatteringDataType>BTDF</ScatteringDataType>
672 <ScatteringData>
673 ';
674 # Output front reflection (transposed order)
675 for (my $od = 0; $od < $ndiv; $od++) {
676 for (my $id = 0; $id < $ndiv; $id++) {
677 chomp $rfarr[$ndiv*$id + $od];
678 print $rfarr[$ndiv*$id + $od], ",\t";
679 }
680 print "\n";
681 }
682 print
683 ' </ScatteringData>
684 </WavelengthDataBlock>
685 </WavelengthData>
686 ';
687 }
688 if ( $doback ) {
689 print
690 ' <WavelengthData>
691 <LayerNumber>System</LayerNumber>
692 <Wavelength unit="Integral">Visible</Wavelength>
693 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
694 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
695 <WavelengthDataBlock>
696 <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
697 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
698 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
699 <ScatteringDataType>BTDF</ScatteringDataType>
700 <ScatteringData>
701 ';
702 # Output back transmission (transposed order)
703 for (my $od = 0; $od < $ndiv; $od++) {
704 for (my $id = 0; $id < $ndiv; $id++) {
705 chomp $tbarr[$ndiv*$id + $od];
706 print $tbarr[$ndiv*$id + $od], ",\t";
707 }
708 print "\n";
709 }
710 print
711 ' </ScatteringData>
712 </WavelengthDataBlock>
713 </WavelengthData>
714 <WavelengthData>
715 <LayerNumber>System</LayerNumber>
716 <Wavelength unit="Integral">Visible</Wavelength>
717 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
718 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
719 <WavelengthDataBlock>
720 <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
721 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
722 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
723 <ScatteringDataType>BTDF</ScatteringDataType>
724 <ScatteringData>
725 ';
726 # Output back reflection (transposed order)
727 for (my $od = 0; $od < $ndiv; $od++) {
728 for (my $id = 0; $id < $ndiv; $id++) {
729 chomp $rbarr[$ndiv*$id + $od];
730 print $rbarr[$ndiv*$id + $od], ",\t";
731 }
732 print "\n";
733 }
734 print
735 ' </ScatteringData>
736 </WavelengthDataBlock>
737 </WavelengthData>
738 ';
739 }
740 }
741 #------------- End of do_matrix_bsdf() --------------#